<script setup lang="ts">
import { onMounted, ref, type Ref } from 'vue'
import ErrorDisplay from './ErrorDisplay.vue'

const props = defineProps<{
  title: string
  message: string
  modalType?: 'yesNo' | 'close'
  onDisplay?: () => Promise<void>
  onAction: () => Promise<void>
}>()

const modalDialog: Ref<HTMLDialogElement | null> = ref(null)
const loading = ref(false)
const loginError: Ref<Error | null> = ref(null)

onMounted(async () => {
  if (props.onDisplay) {
    loading.value = true
    loginError.value = null

    try {
      await props.onDisplay()
    } catch (error) {
      if (!(error instanceof Error)) {
        console.error(error)
      } else {
        loginError.value = error
      }
    }

    loading.value = false
  }
})

async function _onAction() {
  loading.value = true
  loginError.value = null

  try {
    await props.onAction()

    _onClose()
  } catch (error) {
    if (!(error instanceof Error)) {
      console.error(error)
    } else {
      loginError.value = error
    }
  }

  loading.value = false
}

function _onClose() {
  loading.value = false
  loginError.value = null

  if (modalDialog.value) {
    modalDialog.value.close()
  }
}
</script>

<template>
  <div @click="modalDialog!!.showModal">
    <slot></slot>
  </div>
  <dialog id="modalDialog" ref="modalDialog" class="modal modal-bottom sm:modal-middle">
    <div class="modal-box">
      <h3 class="font-bold text-lg whitespace-break-spaces">{{ title }}</h3>
      <p class="py-4 whitespace-break-spaces">{{ message }}</p>

      <ErrorDisplay :login-error="loginError" />

      <div class="modal-action">
        <!-- if there is a button in form, it will close the modal -->
        <div class="contents" v-if="!modalType || modalType === 'close'">
          <button class="btn">Fermer</button>
        </div>
        <div v-else-if="modalType === 'yesNo'" class="flex gap-2">
          <button class="btn" @click="_onAction" :disabled="loading">Oui</button>
          <button class="btn btn-primary" @click="_onClose" :disabled="loading" accesskey="enter">
            Non
          </button>
        </div>
      </div>
    </div>
  </dialog>
</template>
